/* ----- BEGIN LICENSE BLOCK -----
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Kagetaka Libraries.
 *
 * The Initial Developer of the Original Code is Hizuya Atsuzaki
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Hizuya Atsuzaki <hizuya@hizlab.net>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ----- END LICENSE BLOCK ----- */
#include "global.h"
#include "resource.h"
#include "util.h"

#include <stdio.h>
#include <stdarg.h>
#include <windows.h>

void show_message(int uID, ...)
{
	char *buffer;
	char *string;
	va_list arglist;
	
	if (!(buffer = (char *)malloc(512)))
		return;
	if (!(string = get_string_resource(uID)))
		return;
	
	va_start(arglist, uID);
	vsprintf(buffer, string, arglist);
	va_end  (arglist);
	
	free(string);
	
	MessageBox(g_Window, buffer, g_Title, MB_OK);
	
	free(buffer);
}

char *get_string_resource(int uID) {
	LPTSTR lpBuffer;
	int    length;
	
	if (!(lpBuffer = (LPTSTR)malloc(256)))
		return NULL;
	
	length = LoadString(GetModuleHandle(NULL), uID, lpBuffer, 256);
	lpBuffer[length] = 0;
	
	return lpBuffer;
}

void *xmalloc(size_t size) {
	void *p = malloc(size);
	if (!p)
		show_message(IDS_ERROR_MALLOC);
	return p;
}
