/* ----- BEGIN LICENSE BLOCK -----
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Kagetaka Libraries.
 *
 * The Initial Developer of the Original Code is Hizuya Atsuzaki
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Hizuya Atsuzaki <hizuya@hizlab.net>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ----- END LICENSE BLOCK ----- */
package net.hizlab.kagetaka.addin;

import net.hizlab.kagetaka.Resource;

import java.net.URL;
import java.net.URLConnection;

/**
 * åб뤿Υޥ͡Ǥ
 *
 * @author  <A HREF="mailto:hizuya@hizlab.net">Hizuya Atsuzaki</A>
 * @version $Revision: 1.1 $
 */
public abstract class CookieManager {
    private static CookieManagerFactory cookieManagerFactory;
    static {
        try {
            cookieManagerFactory = (CookieManagerFactory) Class.forName(Resource.getMessage("cookiemanager.factory", null)).newInstance();
        } catch (Throwable e) { }
    }

    /**
     * åޥ͡ޤ
     */
    protected CookieManager() {
    }

    /**
     * åޥ͡Υ󥹥󥹤ޤ
     *
     * @return åޥ͡
     */
    public static CookieManager createInstance() {
        if (cookieManagerFactory != null) {
            return cookieManagerFactory.create();
        }

        return null;
    }

    /**
     * ꤵ줿 URL 륯åϤ֤ޤ
     *
     * @param  url å URL
     *
     * @return 륯å
     *         åɬפʤ <code>null</code>
     */
    public abstract String getCookie(URL url);

    /**
     * ꤷåꡢ¸ޤ
     *
     * @param  data <code>Set-Cookie</code> إåʸ
     * @param  url  åȯԤ URL
     */
    public abstract void setCookie(String data, URL url);

    /**
     * URL ˹äåإåꤷޤ
     *
     * @param  connection ͥ
     */
    public abstract void send(URLConnection connection);

    /**
     * إå饯åޤ
     *
     * @param  connection ͥ
     */
    public abstract void receive(URLConnection connection);
}
