/* ----- BEGIN LICENSE BLOCK -----
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Kagetaka Libraries.
 *
 * The Initial Developer of the Original Code is Hizuya Atsuzaki
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Hizuya Atsuzaki <hizuya@hizlab.net>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ----- END LICENSE BLOCK ----- */
package net.hizlab.kagetaka.addin.form;

import net.hizlab.kagetaka.awt.tate.List;
import net.hizlab.kagetaka.rendering.Status;

import java.util.Vector;

/**
 * <code>SELECT</code> ƥʣɽɽ饹Ǥ
 *
 * @author  <A HREF="mailto:hizuya@hizlab.net">Hizuya Atsuzaki</A>
 * @version $Revision: 1.3 $
 */
class ItemList extends ItemSelect {
    private List   list;
    private int[]  lastIndexs;
    private Vector values = new Vector();
    private Vector indexs = new Vector();
    private int    index  = -1;

    /**
     * ꥹȤޤ
     *
     * @param  form     ե
     * @param  type     
     * @param  status   ơ
     * @param  name     ̾
     * @param  c        ݡͥ
     * @param  snapshot ɽκǸξ
     */
    ItemList(Form form, int type, Status status, String name,
             List c, Object snapshot) {
        super(form, type, status, name, c);
        this.list       = c;
        this.lastIndexs = (int[]) snapshot;
    }

    /**
     * ͤɲäޤ
     *
     * @param  value    
     * @param  label    ٥
     * @param  selected Ѥߤξ <code>true</code>
     *                  򤵤Ƥʤ <code>false</code>
     */
    void addValue(String value, String label, boolean selected) {
        list.addItem(label);
        values.addElement(value);

        // ǥեͤ¸
        if (selected) {
            index = values.size() - 1;
            indexs.addElement(Boolean.TRUE );
        } else {
            indexs.addElement(Boolean.FALSE);
        }

        // ξ֤
        if (lastIndexs != null) {
            int curIndex = values.size() - 1;
            int selIndex;
            selected = false;
            for (int i = 0; i < lastIndexs.length; i++) {
                selIndex = lastIndexs[i];
                if (selIndex < curIndex) {
                    continue;
                }
                if (selIndex == curIndex) {
                    selected = true;
                    break;
                }
            }
        }

        if (selected) {
            list.select(values.size() - 1);
        }
    }

    /** {@inheritDoc} */
    boolean getMultipleMode() {
        return list.getMultipleMode();
    }

    /** {@inheritDoc} */
    String getValue() {
        int index = list.getSelectedIndex();
        if (index == -1) {
            return null;
        }

        return (String) values.elementAt(index);
    }

    /** {@inheritDoc} */
    String[] getValues() {
        int[] indexs = list.getSelectedIndexs();
        if (indexs == null || indexs.length == 0) {
            return null;
        }

        String[] v = new String[indexs.length];
        for (int i = 0; i < indexs.length; i++) {
            v[i] = (String) values.elementAt(indexs[i]);
        }

        return v;
    }

    /** {@inheritDoc} */
    Object getSnapshot() {
        return list.getSelectedIndexs();
    }

    /** {@inheritDoc} */
    void reset() {
        if (list.getMultipleMode()) {
            int size = values.size();
            for (int i = 0; i < size; i++) {
                if (((Boolean) indexs.elementAt(i)).booleanValue()) {
                    list.select(i);
                } else {
                    list.deselect(i);
                }
            }
        } else {
            list.select(index);
        }
    }
}
