/* ----- BEGIN LICENSE BLOCK -----
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Kagetaka Libraries.
 *
 * The Initial Developer of the Original Code is Hizuya Atsuzaki
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Hizuya Atsuzaki <hizuya@hizlab.net>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ----- END LICENSE BLOCK ----- */
package net.hizlab.kagetaka.addin.form;

import net.hizlab.kagetaka.awt.tate.TextComponent;
import net.hizlab.kagetaka.awt.tate.TextField;
import net.hizlab.kagetaka.rendering.Status;

/**
 * ƥȥեɡѥɥեɡƥȥꥢɽ饹Ǥ
 *
 * @author  <A HREF="mailto:hizuya@hizlab.net">Hizuya Atsuzaki</A>
 * @version $Revision: 1.3 $
 */
class ItemText extends Item {
    private TextComponent text;

    /**
     * ƥȥեɡѥɥեɡ
     * ƥȥꥢƥޤ
     *
     * @param  form     ե
     * @param  type     
     * @param  status   ơ
     * @param  name     ̾
     * @param  value    
     * @param  c        ݡͥ
     * @param  snapshot ɽκǸξ
     */
    ItemText(Form form, int type, Status status, String name, String value,
             TextComponent c, Object snapshot) {
        super(form, type, status, name, value, c);
        this.text = c;

        // ξ֤
        if (snapshot != null) {
            c.setText((String) snapshot);
        }
    }

    /** {@inheritDoc} */
    String getValue() {
        return text.getText();
    }

    /** {@inheritDoc} */
    Object getSnapshot() {
        return text.getText();
    }

    /** {@inheritDoc} */
    void reset() {
        text.setText(defaultValue);
    }

    /**
     * ɲäޤ
     *
     * @param action 
     */
    void addAction(Action action) {
        if (!(text instanceof TextField)) {
            return;
        }

        TextField tf = (TextField) text;
        tf.addActionListener(action);
    }
}
