/* ----- BEGIN LICENSE BLOCK -----
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Kagetaka Libraries.
 *
 * The Initial Developer of the Original Code is Hizuya Atsuzaki
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Hizuya Atsuzaki <hizuya@hizlab.net>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ----- END LICENSE BLOCK ----- */
package net.hizlab.kagetaka.addin.java2;

import net.hizlab.kagetaka.Resource;
import net.hizlab.kagetaka.util.Environment;

import java.io.File;
import java.io.IOException;

/**
 * Java2  IO 򥵥ݡȤåѡ饹Ǥ
 *
 * @author  <A HREF="mailto:hizuya@hizlab.net">Hizuya Atsuzaki</A>
 * @version $Revision: 1.2 $
 */
public abstract class IOWrapper {
    private static final String RESOURCE = "net.hizlab.kagetaka.addin.java2.Resources";

    private static IOWrapper wrapper;
    static {
        if (Environment.javaVersion >= 102) {
            try {
                wrapper = (IOWrapper) Class.forName(Resource.getMessage(RESOURCE, "bridge.io", null)).newInstance();
            } catch (Throwable e) { }
        }
    }

    /**
     * 󥹥󥹤ޤ
     */
    protected IOWrapper() {
    }

    /**
     * åѡΥ󥹥󥹤֤ޤ
     *
     * @return åѡΥ󥹥
     */
    public static IOWrapper getInstance() {
        return wrapper;
    }

    /**
     * ͭʥե륷ƥΥ롼Ȥꥹɽޤ
     *
     * @return ե륷ƥΥ롼
     */
    public abstract File[] listRoots();

    /**
     * ꤵ줿ǥ쥯ȥǿΥեޤ
     * Υե JavaVM ｪλȺޤ
     *
     * @param  prefix    ե̾뤿˻ѤƬʸ
     *                   <code>3</code> ʸʾĹɬ
     * @param  suffix    ե̾뤿˻Ѥʸ
     *                   <code>null</code> Ǥξϡ
     *                   "<code>.tmp</code>" Ѥ
     * @param  directory ե뤬ǥ쥯ȥꡣ
     *                   ǥեȤΰեǥ쥯ȥ
     *                   Ѥ <code>null</code>
     *
     * @return 줿Υե򼨤ݥѥ̾
     *
     * @throws IOException ե뤬Ǥʤä
     * @throws IllegalArgumentException
     *         <code>prefix</code>  <code3</code3> ʸʤ
     */
    public abstract File createTempFile(String prefix,
                                        String suffix,
                                        File directory)
            throws IOException;
}
