/* ----- BEGIN LICENSE BLOCK -----
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Kagetaka Libraries.
 *
 * The Initial Developer of the Original Code is Hizuya Atsuzaki
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Hizuya Atsuzaki <hizuya@hizlab.net>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ----- END LICENSE BLOCK ----- */
package net.hizlab.kagetaka.io;

import net.hizlab.kagetaka.Debug;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

/**
 * Ȳݻե륯饹Ǥ
 *
 * @author  <A HREF="mailto:hizuya@hizlab.net">Hizuya Atsuzaki</A>
 * @version $Revision: 1.2 $
 */
public class SharedFile extends File {
    /** @serial 󥿡 */
    private int     counter;
    /** @serial 줿 */
    private boolean delete;

    /**
     * ͭեޤ
     *
     * @param  dir  ǥ쥯ȥ
     * @param  file ե
     */
    public SharedFile(String dir, String file) {
        super(dir, file);
    }

    /**
     * եΥץåȥȥ꡼֤ޤ
     * ե뤬Ƥ <code>null</code> ֤ޤ
     *
     * @return եΥץåȥȥ꡼ࡢ
     *         Ƥ <code>null</code>
     *
     * @throws IOException IO 顼ȯ
     */
    public synchronized FileInputStream getInputStream()
            throws IOException {
        if (delete) {
            return null;
        }

        counter++;
        return new SharedFileInputStream();
    }

    /**
     * եޤ
     * եξϡѤƤե뤬ʤʤä
     * ޤ
     *
     * @return ե <code>true</code>
     *         Ǻ <code>false</code>
     */
    public synchronized boolean delete() {
        delete = true;

Debug.out.println("delete=" + getName() + "," + counter);
        if (counter != 0) {
            return false;
        }

Debug.out.println("removeFile=" + getName());
        return super.delete();
    }

//### SharedFileInputStream
    /** ͭեΥץåȥȥ꡼ */
    private final class SharedFileInputStream extends FileInputStream {
        private boolean closed;

        /** 󥹥󥹤 */
        private SharedFileInputStream()
                throws IOException {
            super(SharedFile.this);
        }

        /** Ĥ */
        public void close()
                throws IOException {
            synchronized (SharedFile.this) {
                try {
                    super.close();
                } finally {
                    if (closed) {
                        return;
                    }

                    closed = true;
                    if (--counter == 0 && delete) {
Debug.out.println("removeFile=" + getName());
                        SharedFile.super.delete();
                    }
                }
            }
        }
    }
}
