/* ----- BEGIN LICENSE BLOCK -----
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Kagetaka Libraries.
 *
 * The Initial Developer of the Original Code is Hizuya Atsuzaki
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Hizuya Atsuzaki <hizuya@hizlab.net>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ----- END LICENSE BLOCK ----- */
package net.hizlab.kagetaka.protocol;

import net.hizlab.kagetaka.util.Environment;

/**
 * ǥݡȤƤץȥ򥻥åȥåפޤ
 *
 * @author  <A HREF="mailto:hizuya@hizlab.net">Hizuya Atsuzaki</A>
 * @version $Revision: 1.1.1.1 $
 */
public final class Protocol {
    private static final String PROTOCOL_PACKAGE = "net.hizlab.kagetaka.protocol";
    private static final String PROTOCOL_HANDLER = "java.protocol.handler.pkgs";

    /** ٤¹ */
    static {
        try {
            String pkgs = System.getProperty(PROTOCOL_HANDLER);
            if (pkgs == null) {
                pkgs = PROTOCOL_PACKAGE;
            } else {
                pkgs = PROTOCOL_PACKAGE + "|" + pkgs;
            }

            System.getProperties().put(PROTOCOL_HANDLER, pkgs);
        } catch (SecurityException e) { }
    }

    private static String baseProtocolSet;

    /** ߡ */
    private Protocol() {
    }

    /**
     * ץȥ򥻥åȥåפѤǤ褦ˤޤ
     */
    public static void initialize() {
        // static ֥å¹Ԥ뤿Υߡ᥽å
    }

    /**
     * ١ˤʤץȥϥɥΥ١ѥååȤꤷޤ
     *  {@link #getBaseProtocolSet()} ƤӽФƤ䡢
     * 2 ܰʹߤθƤӽФ̵뤵ޤ
     *
     * @param  set ١ѥåå
     */
    public static void setBaseProtocolSet(String set) {
        if (baseProtocolSet == null) {
            baseProtocolSet = set;
        }
    }

    /**
     * ١ˤʤץȥϥɥΥ١ѥå֤ޤ
     *
     * @return ١ѥå
     */
    public static String getBaseProtocolSet() {
        setBaseProtocolSet(System.getProperty("kagetaka.protocol.base",
                                              Environment.javaVersion >= 102 ? "Hawk2" : "Hawk"));
        return baseProtocolSet;
    }
}
