/* ----- BEGIN LICENSE BLOCK -----
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Kagetaka Libraries.
 *
 * The Initial Developer of the Original Code is Hizuya Atsuzaki
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Hizuya Atsuzaki <hizuya@hizlab.net>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ----- END LICENSE BLOCK ----- */
package net.hizlab.kagetaka.token;

import net.hizlab.kagetaka.rendering.Content;
import net.hizlab.kagetaka.rendering.Reporter;

import java.awt.Color;

/**
 * BODY °ɽ饹Ǥ
 *
 * @author  <A HREF="mailto:hizuya@hizlab.net">Hizuya Atsuzaki</A>
 * @version $Revision: 1.1.1.1 $
 */
public class BodyAttribute extends Attribute {
    private String  attributeBackground = null; // طʲ
    private Color   attributeBgcolor    = null; // طʿ
    private Color   attributeText       = null; // ʸ
    private Color   attributeLink       = null; // 󥯿
    private Color   attributeVLink      = null; // ˬѤߥ󥯿
    private Color   attributeALink      = null; // ƥ֤ʥ󥯿

    /**
     * BODY °ǥեͤǺޤ
     *
     * @param  content  ƥ
     * @param  line     ֹ (<code>1</code> )
     *                     Ǥʤ <code>0</code>
     * @param  column    (<code>1</code> )
     *                     Ǥʤ <code>0</code>
     * @param  reporter 顼ݡ
     */
    protected BodyAttribute(Content content, int line, int column, Reporter reporter) {
        super(content, line, column, reporter);
    }

    /** {@inheritDoc} */
    public boolean setAttribute(String key, String value)
            throws IllegalArgumentException {
        if ("background".compareTo(key) == 0) { attributeBackground = value; return true; }
        if ("bgcolor"   .compareTo(key) == 0) { attributeBgcolor = AttributeConverter.convertToColor(value); return true; }
        if ("text"      .compareTo(key) == 0) { attributeText    = AttributeConverter.convertToColor(value); return true; }
        if ("link"      .compareTo(key) == 0) { attributeLink    = AttributeConverter.convertToColor(value); return true; }
        if ("vlink"     .compareTo(key) == 0) { attributeVLink   = AttributeConverter.convertToColor(value); return true; }
        if ("alink"     .compareTo(key) == 0) { attributeALink   = AttributeConverter.convertToColor(value); return true; }

        return setBaseAttribute(key, value);
    }

//### Original Method
    /**
     * طʥ᡼ URL ֤ޤ
     *
     * @return طʥ᡼ URLꤵƤʤ <code>null</code>
     */
    public String getBackground() {
        return attributeBackground;
    }

    /**
     * طʿ֤ޤ
     *
     * @return طʿꤵƤʤ <code>null</code>
     */
    public Color getBgcolor() {
        return attributeBgcolor;
    }

    /**
     * ʸ֤ޤ
     *
     * @return ʸꤵƤʤ <code>null</code>
     */
    public Color getText() {
        return attributeText;
    }

    /**
     * 󥯿֤ޤ
     *
     * @return 󥯿ꤵƤʤ <code>null</code>
     */
    public Color getLink() {
        return attributeLink;
    }

    /**
     * ˬѤߥ󥯿֤ޤ
     *
     * @return ˬѤߥ󥯿ꤵƤʤ <code>null</code>
     */
    public Color getVLink() {
        return attributeVLink;
    }

    /**
     * ƥ֤ʥ󥯿֤ޤ
     *
     * @return ƥ֤ʥ󥯿ꤵƤʤ <code>null</code>
     */
    public Color getALink() {
        return attributeALink;
    }
}
