/* ----- BEGIN LICENSE BLOCK -----
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Kagetaka Libraries.
 *
 * The Initial Developer of the Original Code is Hizuya Atsuzaki
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Hizuya Atsuzaki <hizuya@hizlab.net>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ----- END LICENSE BLOCK ----- */
package net.hizlab.kagetaka.token.form;

import net.hizlab.kagetaka.rendering.Content;
import net.hizlab.kagetaka.rendering.Reporter;
import net.hizlab.kagetaka.token.Attribute;

/**
 * FORM °ɽ饹Ǥ
 *
 * @author  <A HREF="mailto:hizuya@hizlab.net">Hizuya Atsuzaki</A>
 * @version $Revision: 1.1.1.1 $
 */
public class FormAttribute extends Attribute {
    private String attributeAction        = null; // 
    private String attributeMethod        = null; // ᥽å
    private String attributeEnctype       = null; // 󥳡
    private String attributeAcceptCharset = null; // ʸå
    private String attributeAccept        = null; // եμ
    private String attributeName          = null; // ̾
    private String attributeTarget        = null; // å

    /**
     * FORM °ǥեͤǺޤ
     *
     * @param  content  ƥ
     * @param  line     ֹ (<code>1</code> )
     *                  Ǥʤ <code>0</code>
     * @param  column    (<code>1</code> )
     *                  Ǥʤ <code>0</code>
     * @param  reporter 顼ݡ
     */
    protected FormAttribute(Content content, int line, int column, Reporter reporter) {
        super(content, line, column, reporter);
    }

    /** {@inheritDoc} */
    public boolean setAttribute(String key, String value)
            throws IllegalArgumentException {
        if ("action"        .compareTo(key) == 0) { attributeAction        = value; return true; }
        if ("method"        .compareTo(key) == 0) { attributeMethod        = value; return true; }
        if ("enctype"       .compareTo(key) == 0) { attributeEnctype       = value; return true; }
        if ("accept-charset".compareTo(key) == 0) { attributeAcceptCharset = value; return true; }
        if ("accept"        .compareTo(key) == 0) { attributeAccept        = value; return true; }
        if ("name"          .compareTo(key) == 0) { attributeName          = value; return true; }
        if ("target"        .compareTo(key) == 0) { attributeTarget        = value; return true; }

        return setBaseAttribute(key, value);
    }

//### Original Method
    /**
     * ֤ޤ
     *
     * @return ACTIONꤵƤʤ <code>null</code>
     */
    public String getAction() {
        return attributeAction;
    }

    /**
     * ᥽åɤ֤ޤ
     *
     * @return METHODꤵƤʤ <code>null</code>
     */
    public String getMethod() {
        return attributeMethod;
    }

    /**
     * 󥳡֤ޤ
     *
     * @return ENCTYPEꤵƤʤ <code>null</code>
     */
    public String getEnctype() {
        return attributeEnctype;
    }

    /**
     * ʸåȤ֤ޤ
     *
     * @return ACCEPT-CHARSETꤵƤʤ <code>null</code>
     */
    public String getAcceptCharset() {
        return attributeAcceptCharset;
    }

    /**
     * եμ֤ޤ
     *
     * @return ACCEPTꤵƤʤ <code>null</code>
     */
    public String getAccept() {
        return attributeAccept;
    }

    /**
     * ֤̾ޤ
     *
     * @return NAMEꤵƤʤ <code>null</code>
     */
    public String getName() {
        return attributeName;
    }

    /**
     * åȤ֤ޤ
     *
     * @return TARGETꤵƤʤ <code>null</code>
     */
    public String getTarget() {
        return attributeTarget;
    }
}
