/* ----- BEGIN LICENSE BLOCK -----
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Kagetaka Libraries.
 *
 * The Initial Developer of the Original Code is Hizuya Atsuzaki
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Hizuya Atsuzaki <hizuya@hizlab.net>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ----- END LICENSE BLOCK ----- */
package net.hizlab.kagetaka.viewer;

import net.hizlab.kagetaka.rendering.PostData;

import java.io.ObjectOutputStream;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.io.IOException;
import java.net.URLConnection;
import java.util.Hashtable;

/**
 * Хݻޤ
 *
 * @author  <A HREF="mailto:hizuya@hizlab.net">Hizuya Atsuzaki</A>
 * @version $Revision: 1.2 $
 */
public class Bug implements PostData {
    private Hashtable hash = new Hashtable();

    /**
     * BUG ǡޤ
     *
     * @param  url       URL
     * @param  message   å
     * @param  throwable 㳰
     */
    public Bug(String url, String message, Throwable throwable) {
        hash.put("report.crash.data.url"      , url    );
        hash.put("report.crash.data.message"  , message);
        StringWriter sw = new StringWriter(  );
        PrintWriter  pw = new PrintWriter (sw);
        throwable.printStackTrace(pw);
        pw.flush();
        pw.close();
        hash.put("report.crash.data.throwable", sw.toString());
    }

    /** {@inheritDoc} */
    public void send(URLConnection connection)
            throws IOException {
        connection.setDoOutput(true);

        ObjectOutputStream oos = new ObjectOutputStream(connection.getOutputStream());
        try {
            oos.writeObject(hash);
            oos.flush();
        } catch (IOException e) {
        } finally {
            try {
                oos.close();
            } catch (IOException ex) { }
        }
    }
}
