/* ----- BEGIN LICENSE BLOCK -----
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Kagetaka Libraries.
 *
 * The Initial Developer of the Original Code is Hizuya Atsuzaki
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Hizuya Atsuzaki <hizuya@hizlab.net>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ----- END LICENSE BLOCK ----- */
package net.hizlab.kagetaka.test;

import net.hizlab.kagetaka.awt.ImageCreator;
import net.hizlab.kagetaka.awt.image.OffscreenBuffer;
import net.hizlab.kagetaka.awt.tate.List;
import net.hizlab.kagetaka.rendering.Option;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.PrintWriter;

/**
 * {@link List} ΥƥȤ򤹤륯饹Ǥ
 *
 * @author  <A HREF="mailto:hizuya@hizlab.net">Hizuya Atsuzaki</A>
 * @version $Revision: 1.1 $
 */
public class AwtTateListTester extends Tester {
    /**
     * 󥹥󥹤ޤ
     */
    protected AwtTateListTester() {
    }

    /* γפ֤ޤ*/
    /** {@inheritDoc} */
    protected String getArgumentsSummary() {
        return "";
    }

    /* ξܺ٤<code>out</code> ˽Ϥޤ*/
    /** {@inheritDoc} */
    protected void printArgumentsDescription(PrintWriter out) {
    }

    /**
     * ĽܥåɽԤޤ
     *
     * @param  args {@inheritDoc}
     *
     * @return {@inheritDoc}
     */
    protected int execute(String[] args) {
        TateFrame tateFrame = new TateFrame("Tate List Tester");
        tateFrame.show();

        try {
            synchronized (this) {
                wait();
            }
        } catch (InterruptedException e) {
            tateFrame.dispose();
        }

        return 0;
    }

    /**
     * Ľܥåɽ뤿Υե졼Ǥ
     */
    private final class TateFrame extends Frame
            implements ImageCreator {

        /** @serial ե꡼󥤥᡼ */
        private OffscreenBuffer offscreenBuffer;

        /**
         * ե졼ޤ
         *
         * @param  title ե졼Υȥ
         */
        private TateFrame(String title) {
            super(title);

            offscreenBuffer = new OffscreenBuffer(this);
            Option option = new Option();

            setLayout(new FlowLayout(FlowLayout.CENTER, 0, 0));
            List list;

            // 1. 
            add(list = new List(option, this));

            // 2. 򤢤
            add(list = new List(option, this));
            list.addItem("ܸ죱");
            list.addItem("English1");
            list.addItem("ܸ죱English1");
            list.addItem("12345");
            list.addItem("ܸ죲");
            list.addItem("English2");
            list.addItem("ܸ죲English2");
            list.addItem("67890");
            list.select(2);

            // 3. ʤ
            add(list = new List(option, this, 10));
            list.addItem("ܸ죱");
            list.addItem("English1");
            list.addItem("ܸ죱English1");
            list.addItem("12345");
            list.addItem("ܸ죲");
            list.addItem("English2");
            list.addItem("ܸ죲English2");
            list.addItem("67890");
            list.addItem("ܸ죳");
            list.addItem("English3");
            list.addItem("ܸ죳English3");
            list.addItem("abcde");
            list.addItem("ܸ죴");
            list.addItem("English4");
            list.addItem("ܸ죴English4");
            list.addItem("fghij");

            // 4. ʣ򤢤
            add(list = new List(option, this, 10, true));
            list.addItem("ܸ죱");
            list.addItem("English1");
            list.addItem("ܸ죱English1");
            list.addItem("12345");
            list.addItem("ܸ죲");
            list.addItem("English2");
            list.addItem("ܸ죲English2");
            list.addItem("67890");
            list.addItem("ܸ죳");
            list.addItem("English3");
            list.addItem("ܸ죳English3");
            list.addItem("abcde");
            list.addItem("ܸ죴");
            list.addItem("English4");
            list.addItem("ܸ죴English4");
            list.addItem("fghij");
            list.select(2);
            list.select(4);
            list.select(13);

            // 5. null 
            add(list = new List(option, this));
            list.addItem((String) null);
            list.addItem((String) null);

            // 6. 
            add(list = new List(option, this, 5));
            list.addItem("ܸ죱");

            pack();

            // Ĥ褦ˤ
            addWindowListener(
                new WindowAdapter() {
                    public void windowClosing(WindowEvent e) {
                        dispose();
                        System.exit(0);
                    }
                }
            );

            // ɽ
            Dimension screenSize = getToolkit().getScreenSize();
            Dimension windowSize = getSize();
            setLocation((screenSize.width  - windowSize.width ) / 2,
                        (screenSize.height - windowSize.height) / 2);
        }

        /**
         * ̤򥢥åץǡȤޤ
         *
         * @param  g եå
         */
        public void update(Graphics g) {
            paint(g);
        }

        /**
         * ᡼ºݤ褷ޤ
         *
         * @param  g եå
         */
        public void paint(Graphics g) {
            offscreenBuffer.paint(g);
        }
    }
}
