/* ----- BEGIN LICENSE BLOCK -----
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Kagetaka Libraries.
 *
 * The Initial Developer of the Original Code is Hizuya Atsuzaki
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Hizuya Atsuzaki <hizuya@hizlab.net>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ----- END LICENSE BLOCK ----- */
package net.hizlab.kagetaka.awt.event;

import java.awt.Adjustable;

/**
 * Ƥɽޤ
 *
 * @author  <A HREF="mailto:hizuya@hizlab.net">Hizuya Atsuzaki</A>
 * @version $Revision: 1.1.1.1 $
 */
public class AdjustmentEvent extends java.awt.event.AdjustmentEvent {
//    private static final long serialVersionUID = -2025545748456852899L;

    /** ͤѹ줿 */
    public static final int ADJUSTMENT_VALUE_USER_CHANGED = RESERVED_ID_MAX + 1041;

    /**
     * ꤵ줿֥Ȥ AdjustmentEvent ֥Ȥޤ
     *
     * @param  source  ٥Ȥθˤʤ륪֥
     * @param  id      ٥ȤΥ
     * @param  type    
     * @param  value   
     */
    public AdjustmentEvent(Adjustable source, int id, int type, int value) {
        super(source, id, type, value);
    }

    /**
     * Υ٥Ȥʸ֤ޤ
     *
     * @return ٥ʸ
     */
    public String paramString() {
        String typeStr;

        switch(id) {
        case ADJUSTMENT_VALUE_USER_CHANGED: typeStr = "ADJUSTMENT_VALUE_USER_CHANGED"; break;
        default                           : typeStr = "unknown type";
        }

        String adjTypeStr;
        switch(getAdjustmentType()) {
        case UNIT_INCREMENT:
            adjTypeStr = "UNIT_INCREMENT";
            break;
        case UNIT_DECREMENT:
            adjTypeStr = "UNIT_DECREMENT";
            break;
        case BLOCK_INCREMENT:
            adjTypeStr = "BLOCK_INCREMENT";
            break;
        case BLOCK_DECREMENT:
            adjTypeStr = "BLOCK_DECREMENT";
            break;
        case TRACK:
            adjTypeStr = "TRACK";
            break;
        default:
            adjTypeStr = "unknown type";
        }
        return typeStr + ",adjType=" + adjTypeStr + ",value=" + getValue();
    }
}
